package cz.agents.alite.vis3d.control;

import com.jme3.scene.Spatial;
import cz.agents.alite.vis3d.model.WheeledModel;
import cz.agents.alite.vis3d.spatial.WheeledSpatial;

public class WheelsControl extends AbstractControlExtend {

    private WheeledModel model;

    public WheelsControl(WheeledModel model) {
        this.model = model;
    }

    @Override
    protected void controlUpdate(float tpf) {
        WheeledSpatial wheeledSpatial = (WheeledSpatial) spatial;

        for (String wheelName : wheeledSpatial.getWheelNames()) {
            Spatial wheel = wheeledSpatial.getWheel(wheelName);
            wheel.setLocalTranslation(model.getWheelTranslation(wheelName));
            wheel.setLocalRotation(model.getWheelRotation(wheelName));
        }
    }
}
