package cz.agents.alite.vis3d.layer;

import com.jme3.math.Quaternion;
import com.jme3.math.Transform;
import com.jme3.math.Vector3f;
import cz.agents.alite.vis3d.Vis3d;

public class DefaultSetting3DLayer implements Vis3DLayer {

    public static final Vector3f DEFAULT_TRANSLATION = new Vector3f(0, 0, 0);
    public static final Quaternion DEFAULT_ROTATION = new Quaternion().fromAngles(0, 0, 0);
    public static final float DEFAULT_SCALE = 1f;
    private static final Vector3f DEFAULT_CAM_LOCATION = new Vector3f(100, 100, 100);
    private static final Vector3f DEFAULT_CAM_LOOK_AT = new Vector3f(200, 0, 200);

    @Override
    public void init(Vis3d vis) {
        vis.setDefaultCamLocation(setDefaultCamLocation());
        vis.setDefaultCamLookAt(setDefaultCamLookAt());
        setDefaultWorldTransform(vis);
    }

    protected Vector3f setDefaultCamLocation() {
        return DEFAULT_CAM_LOCATION;
    }

    protected Vector3f setDefaultCamLookAt() {
        return DEFAULT_CAM_LOOK_AT;
    }

    private void setDefaultWorldTransform(Vis3d vis) {
        Transform trRef = new Transform();
        trRef.setTranslation(setDefaultWorldTranslation());
        trRef.setRotation(setDefaultWorldRotation());
        trRef.setScale(setDefaultWorldScale());
        vis.setWorldTransform(trRef);
    }

    protected float setDefaultWorldScale() {
        return DEFAULT_SCALE;
    }

    protected Quaternion setDefaultWorldRotation() {
        return DEFAULT_ROTATION;
    }

    protected Vector3f setDefaultWorldTranslation() {
        return DEFAULT_TRANSLATION;
    }
}
