package cz.agents.alite.vis3d.layer;

import cz.agents.alite.vis3d.Vis3d;
import java.util.LinkedList;
import java.util.List;

public class Group3DLayer implements GroupVis3DLayer {

    private List<Vis3DLayer> subLayers = new LinkedList<Vis3DLayer>();

    protected Group3DLayer() {
    }

    @Override
    public void addSubLayer(Vis3DLayer layer) {
        subLayers.add(layer);
    }

    @Override
    public void removeSubLayer(Vis3DLayer layer) {
        subLayers.remove(layer);
    }

    @Override
    public void init(Vis3d vis) {
        for (Vis3DLayer layer : subLayers) {
            layer.init(vis);
        }
    }

    public List<Vis3DLayer> getSubLayers() {
        return subLayers;
    }

    public static Group3DLayer create() {
        return new Group3DLayer();
    }
}
