package tacv.universe.entity.car;

import cz.agents.alite.common.entity.Entity;
import java.util.LinkedList;
import tacv.universe.environment.AgentScoutEnvironment.AgentScoutEnvironmentHandler;
import tacv.universe.environment.sensor.AlarmSensor;
import tacv.universe.environment.sensor.CarSensor;
import tacv.universe.environment.sensor.callback.AlarmCallback;
import tacv.util.Point;

/**
 *
 * @author Jiri Vokrinek
 */
public abstract class AbstractCarAgent extends Entity {

    public static final Float TARGET_SPEED = 35f;
    protected final AgentScoutEnvironmentHandler handler;
    protected final CarSensor carSensor;
    protected final AlarmSensor alarmSensor;
    // TODO: stuck sensor or collision sensor??
    private LinkedList<Point> plan;

    /**
     *
     * @param name
     * @param map
     * @param handler
     */
    public AbstractCarAgent(final String name, final AgentScoutEnvironmentHandler handler) {
        super(name);
        this.handler = handler;
        carSensor = this.handler.addSensor(CarSensor.class, this);
        alarmSensor = handler.addSensor(AlarmSensor.class, this);
        alarmSensor.registerAlarmCallback(1, new AlarmCallback() {
            @Override
            public void senseAlarm(long simulationTime) {
                ready();
            }
        });
    }

    /**
     * Called at the beginning of simulation after the environment is
     * initialized
     */
    protected abstract void ready();
}
