package tacv.universe.entity.embodiment;

import javax.vecmath.Vector3f;

import cz.agents.alite.planner.spatialmaneuver.GeometryUtils;

public class CarRegulator {

    private static final double P_ANGLE = 1.0;
    private static final double P_SPEED = 500;

    public Action calculateAction(double desiredSpeed, Vector3f desiredHeading, double speed, Vector3f heading) {
        double diffAngle = P_ANGLE * GeometryUtils.angleBetweenVectors(heading.x, heading.z, desiredHeading.x, desiredHeading.z);
        double diffSpeed = P_SPEED * (desiredSpeed - speed);
        return new Action(diffSpeed, -diffAngle);
    }

    public static class Action {
        final double force;
        final double steer;

        public Action(double force, double steer) {
            this.force = force;
            this.steer = steer;
        }

        @Override
        public String toString() {
            return "F: " + force + "S: " + steer;
        }
    }
}
