package tacv.universe.environment.sensor;

import cz.agents.alite.common.entity.Entity;
import cz.agents.alite.common.event.Event;
import cz.agents.alite.environment.eventbased.EventBasedSensor;
import java.util.HashMap;
import java.util.Map;
import tacv.universe.environment.AgentScoutEnvironment;
import tacv.universe.environment.sensor.callback.ClockTickCallback;
import tacv.util.TacEventType;

public class ClockSensor extends EventBasedSensor {

    private long tickIntervalInMs = 10000; // 10 sec
    private final Map<String, ClockTickCallback> clockTickCallbacks = new HashMap<String, ClockTickCallback>();

    public ClockSensor(AgentScoutEnvironment environment, Entity relatedEntity) {
        super(environment, relatedEntity);

        getEventProcessor().addEvent(TacEventType.CLOCK_TICK, ClockSensor.this, null, null, tickIntervalInMs);
    }

    public void registerClockTickCallback(ClockTickCallback clockTickCallback) {
        clockTickCallbacks.put(getRelatedEntity().getName(), clockTickCallback);
    }

    @Override
    public void handleEvent(Event event) {
        if (event.isType(TacEventType.CLOCK_TICK)) {
            clockTickCallbacks.get(getRelatedEntity().getName()).senseClockTick(getEventProcessor().getCurrentTime());
            getEventProcessor().addEvent(TacEventType.CLOCK_TICK, ClockSensor.this, null, null, tickIntervalInMs);
        } else {
            super.handleEvent(event);
        }

    }

    public void setTickIntervalInMs(long tickIntervalInMs) {
        this.tickIntervalInMs = tickIntervalInMs;
    }
}
