package tacv.vis3d.layer;

import com.jme3.bounding.BoundingBox;
import com.jme3.math.Quaternion;
import com.jme3.scene.Spatial;
import cz.agents.alite.vis3d.Vis3d;
import cz.agents.alite.vis3d.layer.Common3DLayer;
import cz.agents.alite.vis3d.layer.Vis3DLayer;
import java.util.ArrayList;
import java.util.List;

public class Village3DLayer {

    private static final String MODEL_VILLAGE_MESH = "models/village/village2.mesh.xml";
    private static final Quaternion MODEL_LOAD_ROTATION = new Quaternion().fromAngles(0, 0, 0);

    public static Vis3DLayer create() {
        return new Common3DLayer() {

            @Override
            protected List<Spatial> createSpatials(Vis3d vis) {
                List<Spatial> ret = new ArrayList<Spatial>();
                Spatial ground = vis.getAssetManager().loadModel(MODEL_VILLAGE_MESH);
                ground.rotate(MODEL_LOAD_ROTATION);
                ground.setModelBound(new BoundingBox());
                ret.add(ground);
                return ret;
            }
        };
    }
}
