package tacv.vis3d.model;

import com.jme3.math.Quaternion;
import com.jme3.math.Vector3f;
import tacv.settings.CoordsSettings;
import tacv.util.Converter;
import cz.agents.alite.vis3d.model.VehicleModel;
import tacv.universe.entity.embodiment.AutomaticRegularCar;

public class BulletCarPhysicalModelAdapter implements VehicleModel {

    private AutomaticRegularCar car;

    public BulletCarPhysicalModelAdapter(AutomaticRegularCar car) {
        super();
        this.car = car;
    }

    @Override
    public Quaternion getRotation() {
        return Converter.convertQuat(car.getRotation(), CoordsSettings.PROJECT_COORDS, new Quaternion(), CoordsSettings.JME_COORDS);
    }

    @Override
    public Vector3f getTranslation() {
        return Converter.convertVec(car.getActualPosition(), CoordsSettings.PROJECT_COORDS, new Vector3f(), CoordsSettings.JME_COORDS);
    }

    @Override
    public Quaternion getWheelRotation(String wheelName) {
        return Converter.convertQuat(car.getWheelRotation(wheelName), CoordsSettings.PROJECT_COORDS, new Quaternion(), CoordsSettings.JME_COORDS);
    }

    @Override
    public Vector3f getWheelTranslation(String wheelName) {
        return Converter.convertVec(car.getWheelTranslation(wheelName), CoordsSettings.PROJECT_COORDS, new Vector3f(), CoordsSettings.JME_COORDS);
    }
}
