package tacv.vis3d.spatial;

import java.awt.Color;


public class ColorSettings {

    public final static ColorSettings RED   = new ColorSettings( 201,   0,  37, 1f);
    public final static ColorSettings GREEN = new ColorSettings( 134, 201,   0, 1f);
    public final static ColorSettings BLUE  = new ColorSettings(   0, 130, 202, 1f);
    public final static ColorSettings GRAY  = new ColorSettings( 203, 203, 203, 1f);
    public final static ColorSettings WHITE  = new ColorSettings( 255, 255, 25, 1f);
    public final static ColorSettings ORANGE = new ColorSettings( 208, 125, 0, 1f);

    public int r,g,b;
    public float a;
    public ColorSettings(int r, int g, int b, float a) {
        super();
        this.r = r;
        this.g = g;
        this.b = b;
        this.a = a;
    }

    public ColorSettings setAlpha(float a){
        this.a = a;
        return this;
    }

    @Override
    public boolean equals(Object obj) {
        if(obj instanceof ColorSettings){
            ColorSettings cs = (ColorSettings) obj;
            return cs.r == r && cs.g == g && cs.b == b;
        }
        return super.equals(obj);
    }

    public static ColorSettings get(ColorSettings cs){
        return new ColorSettings(cs.r, cs.g, cs.b, cs.a);
    }

    public static ColorSettings get(Color color) {
        return new ColorSettings(color.getRed(), color.getGreen(), color.getBlue(), 1f);
    }
}
